(********************************************************************)
(*                                                                  *)
(*                                 KEYS.PAS                         *)
(*                                                                  *)
(*                               Keyboard Unit                      *)
(*                                                                  *)
(*                                                                  *)
(*                            Copyright (c) 1999                    *)
(*                      Mark J Iuzzolino, Daniel Robbins            *)
(*                            All Rights Reserved                   *)
(*                                                                  *)
(*                                                                  *)
(*                                                                  *)
(********************************************************************)

(*
 *   Rev 1.0  1999/06/01 mji
 * Released
 *)

{$IFDEF DPMI}

{$A+,B-,D-,E+,F-,G+,I+,L+,N-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0}

{$ELSE}

{$A+,B-,D-,E+,F-,G+,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

{$ENDIF}

unit keys;
{$IFDEF DPMI}
  {$C FIXED PRELOAD PERMANENT}
{$ENDIF}

interface

uses dos;

const KY_ESC=1;
      KY_1=2;
      KY_2=3;
      KY_3=4;
      KY_4=5;
      KY_5=6;
      KY_6=7;
      KY_7=8;
      KY_8=9;
      KY_STAR=9;
      KY_9=10;
      KY_0=11;
      KY_MINUS=12;
      KY_UNDERSCORE=12;
      KY_PLUS=13;
      KY_EQUALS=13;
      KY_BACKSPACE=14;
      KY_TAB=15;
      KY_Q=16;
      KY_W=17;
      KY_E=18;
      KY_R=19;
      KY_T=20;
      KY_Y=21;
      KY_U=22;
      KY_I=23;
      KY_O=24;
      KY_P=25;
      KY_LEFTBRACE=26;
      KY_LEFTBRACKET=26;
      KY_RIGHTBRACE=27;
      KY_RIGHTBRACKET=27;
      KY_ENTER=28;
      KY_CTRL=29;
      KY_A=30;
      KY_S=31;
      KY_D=32;
      KY_F=33;
      KY_G=34;
      KY_H=35;
      KY_J=36;
      KY_K=37;
      KY_L=38;
      KY_SEMICOLON=39;
      KY_COLON=39;
      KY_TICK=40;
      KY_APOSTROPHE=40;
      KY_TILDE=41;
      KY_LEFTTICK=41;
      KY_OPENQUOTE=41;
      KY_LEFTSHIFT=42;
      KY_BACKSLASH=43;
      KY_PIPE=43;
      KY_BAR=43;
      KY_Z=44;
      KY_X=45;
      KY_C=46;
      KY_V=47;
      KY_B=48;
      KY_N=49;
      KY_M=50;
      KY_COMMA=51;
      KY_LESSTHAN=51;
      KY_PERIOD=52;
      KY_GREATERTHAN=52;
      KY_GRAYSLASH=53;
      KY_RIGHTSHIFT=54;
      KY_GRAYSTAR=55;
      KY_ALT=56;
      KY_SPACE=57;
      KY_CAPS=58;
      KY_CAPSLOCK=58;
      KY_F1=59;
      KY_F2=60;
      KY_F3=61;
      KY_F4=62;
      KY_F5=63;
      KY_F6=64;
      KY_F7=65;
      KY_F8=66;
      KY_F9=67;
      KY_F10=68;
      KY_NUMLOCK=69;
      KY_SCROLLLOCK=70;
      KY_HOME=71;
      KY_UP=72;
      KY_PGUP=73;
      KY_GRAYMINUS=74;
      KY_LEFT=75;
      KY_GRAYFIVE=76;
      KY_RIGHT=77;
      KY_GRAYPLUS=78;
      KY_END=79;
      KY_DOWN=80;
      KY_PGDN=81;
      KY_INS=82;
      KY_DEL=83;
      KY_F11=87;
      KY_F12=88;
      KY_PAUSE=197;

var KeyHit : array[byte] of boolean; {array of hit keys}
    __key:byte;
    KeyInstalled:boolean;

var ReadKey:function:Char;
var KeyPressed:function:Boolean;

function readScanCode:byte;
procedure SetKbdInterrupt;
procedure RestoreKbdInterrupt;

implementation

{This would almost be funny if it weren't necessary}
{const NonCharKeys:set of byte=[KY_LEFTSHIFT,KY_RIGHTSHIFT,KY_ALT,KY_CTRL,KY_F1,
                               KY_F2,KY_F3,KY_F4,KY_F5,KY_F6,KY_F7,KY_F8,KY_F9,
                               KY_f10,KY_F11,KY_F12,KY_PGDN,KY_PGUP,KY_LEFT,
                               KY_RIGHT,KY_UP,KY_DOWN,KY_INS,KY_DEL,KY_CAPS,
                               KY_HOME,KY_END];}
const KEYBOARD_INT    =$09;
const KEY_BUFFER      =$60;
const KEY_CONTROL     =$61;
const INT_CONTROL     =$20;

const KeyTranslationTable:string[88]=
       #27+'1234567890-='+#8+#9+ {tab is 15}
           'qwertyuiop[]'+#13+'_'+ {enter is 28, ctrl is 29}
           'asdfghjkl;''` \'+ {z is 44}
           'zxcvbnm,./_*_ ________________-_5_+__________';


const CharKeys:set of byte=[KY_ESC..KY_ENTER,KY_A..KY_LEFTTICK,KY_BACKSLASH..KY_GRAYSLASH,
                            KY_GRAYSTAR,KY_SPACE,KY_GRAYMINUS,KY_GRAYPLUS,KY_GRAYSLASH];
var Int09Save : procedure;
    OldKbdflag:byte;

{$F+} {has to be far because it is an interrupt}
procedure KbdHandler2; interrupt; assembler;
asm
        in      al,KEY_BUFFER
        mov     __key,al
        mov     bl,al
{        in      al,KEY_CONTROL
        or      al,80h
        out     KEY_CONTROL,al
        and     al,7fh
        out     KEY_CONTROL,al
}
	mov	al,bl
	and	bx,$7F	{remove hitstatus bit and clear BH}
	and	al,al
	 jns	@pressing
	mov	BYTE PTR [bx+OFFSET keyhit],FALSE
	 jmp	near ptr @done
@pressing:
	mov	BYTE PTR [bx+OFFSET keyhit],TRUE
@done:
        mov     al,20h
        out     INT_CONTROL,al  {Send non-specific EOI}
end;

{these functions have to be far since we are using a pointer to a function.}
function OldKeypressed:boolean;assembler;
asm
        mov     ah,11h
        int     16h
        mov     al,FALSE
        jz      @false
        mov     al,TRUE
@false:
end;

function Newkeypressed:boolean;
var k:byte;
begin
 if __key>=128 then __key:=0;
 Newkeypressed:=(__key<>0) and (__key in CharKeys)
end;

function oldreadkey:char; assembler;
asm
        mov     ax,10h
        int     16h
        or      al,al
         jnz    @@done
        mov     cl,ah
        xor     ch,ch
        mov     ah,05h     {push the character back on the keyboard queue}
        int     16h
        xor     al,al      {hope the keyboard buffer isn't full}
@@done:
end;

function NewReadkey:char;
var k:byte;
    c:char;
begin
 repeat
  k:=__key;  {assign it to a variable to avoid semaphore problems}
 until k in CharKeys;

 __key:=0; {do this as soon as possible so next key can be placed in there.}

 c:=KeyTranslationTable[k];
 if KeyHit[KY_LEFTSHIFT] or KeyHit[KY_RIGHTSHIFT] then
  case c of
   'a'..'z' : c:=upcase(c);
   ';': c:=':';
   '''': c:='"';
   '1': c:='!';
   '2': c:='@';
   '3': c:='#';
   '4': c:='$';
   '5': c:='%';
   '6': c:='^';
   '7': c:='&';
   '8': c:='*';
   '9': c:='(';
   '0': c:=')';
   '-': if (k<>KY_GRAYMINUS) then c:='_';
   '=': c:='+';
   '[': c:='{';
   ']': c:='}';
   '\': c:='|';
   '`': c:='~';
   ',': c:='<';
   '.': c:='>';
   '/': c:='?';
  end;
 NewReadkey:=c;
end;
{$F-}

{Functions after here don't need to be far (but probably are).}

function readScanCode:byte;
begin
 if KeyInstalled then
  begin
   repeat
    if __key>128 then __key:=0;
   until __key<>0;
   readScanCode:=__key;
   __key:=0
  end
 else ReadScanCode:=KY_ESC  {Simulate an ESC to prevent crashes}
end;

procedure SetKbdInterrupt;
begin
 if KeyInstalled then exit;
 __Key:=0;
 fillchar(Keyhit,Sizeof(KeyHit),FALSE);
 OldKbdFlag:=mem[seg0040:$17] and $F0;
 GetIntVec($09,@Int09Save);
 SetIntVec($09,addr(KbdHandler2));
 @ReadKey:=@NEwReadKey;
 @KeyPressed:=@NewKeyPressed;
 KeyInstalled:=TRUE
end;

procedure RestoreKbdInterrupt;
begin
 if not KeyInstalled then exit;
 SetIntVec($09,@Int09Save);
 @ReadKey:=@OldReadKey;
 @KeyPressed:=@OldKeyPressed;
 mem[Seg0040:$17]:=OldKbdFlag;
 KeyInstalled:=FALSE
end;

begin
 KeyInstalled:=FALSE;
 @ReadKey:=@OldReadKey;
 @KeyPressed:=@OldKeyPressed;
end.
