; File:
;                                OBJGFX8.ASM
; Description:
;     Assembly support routines for ObjGfx8
;
;                             Copyright (c) 1999
;                       Mark J Iuzzolino, Daniel Robbins
;                             All Rights Reserved
;
; This file is part of ObjGfx.
;
; ObjGfx is a free software library; you can redistribute it and/or
; modify it under the terms of the GNU Library General Public License
; as published by the Free Software Foundation; either version
; 2, or (at your option) any later version.
;
; ObjGfx is distributed in the hope that it will be useful, but
; WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
; the GNU Library General Public License for more details.
;
; You should have received a copy of the GNU Library General Public License
; along with ObjGfx; see the file COPYING.  If not,
; write to the Free Software Foundation, 675 Mass Ave,
; Cambridge, MA 02139, USA.
;
;
;    Rev 2.0  1999/06/01 mji
;  Released
;    Rev 1.9  1999/05/24 mji
;  Changed LineOffsets to 4096 lines
;  Made TransparentColour a dword
;  Added TGfx0; changed Vesa8 to TScreen8; made source mods to reflect these
;  changes
;  Changed all colour args from a byte to a dword
;

.model tpascal
.386
.DATA

 FALSE EQU 0
 TRUE EQU 1

 EXTRN TransparentColour  : dword

TGfx0 struc GLOBAL METHOD {
;  virtual procedure:dword=TGFx0@procedure
  }
  LineOffsets dd 4096 dup (?)
  xRes dw ?
  yRes dw ?
  GetMaxX dw ?
  GetMaxY dw ?

  CurDataState db ?
  bpp db ?
  _data dw ?
  _InternalOffset dd ?
  _VMT dw ?              ; this is added by the compiler

TGfx0 ENDS

TGfx8 struc GLOBAL TGfx0 METHOD {
  }
  pal db 768 dup (?)

TGfx8 ENDS

TScreen8 struc GLOBAL TGfx8 METHOD {
  }
  VesaRec dd ?
  ModeRec dd ?
  SwitchBank dd ?
  ;------- private area-----------
  _BankVals dw 480 dup (?)
  _CurWriteBank dw ?
  _CurReadBank dw ?
  _ReadWindow dw ?
  _VesaSelector dw ?
  _CodeSelector dw ?
  _InGraphics db ?
  _LFB db ?
TScreen8 ENDS

.CODE
LOCALS @@

PUBLIC CompressLine_MOOISHI
PUBLIC DeCompressLine_MOOISHI
PUBLIC CompressLine_PCX
PUBLIC DeCompressLine_PCX
PUBLIC DeCompressLine_PBM
PUBLIC DeCompressLine_IFF

PUBLIC TGfx8@Clear
PUBLIC TGfx8@FlipY
PUBLIC TGfx8@HorizLine
PUBLIC TGfx8@GetImage
PUBLIC TGfx8@GetPixel
PUBLIC TGfx8@PutBlit
PUBLIC TGfx8@PutImage
PUBLIC TGfx8@PutPixel
PUBLIC TGfx8@RawLine
PUBLIC TGfx8@ScaleBuf
PUBLIC TGfx8@VertLine

PUBLIC TScreen8@Clear
PUBLIC TScreen8@CopyLineFromScreen
PUBLIC TScreen8@CopyLineToScreen
PUBLIC TScreen8@HorizLine
PUBLIC TScreen8@GetImage
PUBLIC TScreen8@GetPixel
PUBLIC TScreen8@PutBlit
PUBLIC TScreen8@PutImage
PUBLIC TScreen8@PutPixel
PUBLIC TScreen8@RawLine
PUBLIC TScreen8@ScaleBuf
PUBLIC TScreen8@VertLine

CompressLine_Mooishi proc far
arg @@src:pword,@@dest:pword,@@endofline:dword,@@compclr1:byte,@@compclr2:byte,@@compclr3:byte,@@compclr4:byte,@@size:dword

        push    ds
        xor     ecx,ecx

        lds     esi,@@src
        les     edi,@@dest
@@start:mov     edx,@@endofline
        cmp     esi,edx
         je     @@nomoremushy

        mov     al,ds:[esi]

        dec     edx             ; edx = @@endofline-1
        cmp     esi,edx
         je     @@movsb   ; one pixel left

        sub     edx,3           ; edx = @@endofline-4
        cmp     esi,edx
         jae    @@cmpcolour

        cmp     al,ds:[esi+1]
         jne    short @@cmpwords
        cmp     al,ds:[esi+2]
         jne    short @@cmpwords
        cmp     al,ds:[esi+3]
         jne    short @@cmpwords

        mov     cx,4
        add     edx,ecx
        add     esi,ecx
@@bytecheck:
        cmp     esi,edx
         je     short @@donewithbytes
        cmp     al,ds:[esi]
        jne     short @@donewithbytes
        inc     esi
        inc     ecx
        jmp     short @@bytecheck
@@donewithbytes:
        cmp     cx,255
         ja     short @@c1
@@c2:   mov     bl,@@compclr2
        mov     es:[edi],bl
        mov     es:[edi+1],cl
        mov     es:[edi+2],al
        add     edi,3

         jmp    short @@start
@@c1:   mov     bl,@@compclr1
        mov     es:[edi],bl
        mov     es:[edi+1],cx
        mov     es:[edi+3],al
        add     edi,4
         jmp    @@start

@@cmpwords:
        mov     ax,ds:[esi]
        sub     edx,2           ; edx = @@endofline-6
        cmp     esi,edx
         jae    short @@cmpcolour
        add     edx,4           ; edx = @@endofline-2

        cmp     ax,ds:[esi+2]
         jne    short @@cmpcolour
        cmp     ax,ds:[esi+4]
         jne    short @@cmpcolour
        mov     cx,3
        add     esi,6
        inc     edx
@@wordcheck:
        cmp     esi,edx
         je     short @@donewithwords
        cmp     ax,ds:[esi]
         jne    short @@donewithwords
        inc     cx
        add     esi,2
         jmp    short @@wordcheck
@@donewithwords:
        cmp     cx,255
         ja     short @@c3
@@c4:   mov     bl,@@compclr4
        mov     es:[edi],bl
        mov     es:[edi+1],cl
        mov     es:[edi+2],ax
        add     edi,4
         jmp    @@start
@@c3:   mov     bl,@@compclr3
        mov     es:[edi],bl
        mov     es:[edi+1],cx
        mov     es:[edi+3],ax
        add     edi,5
         jmp    @@start
@@cmpcolour:
        inc     esi
        mov     cx,1
        cmp     al,@@compclr1
         je     @@c2
        cmp     al,@@compclr2
         je     @@c2
        cmp     al,@@compclr3
         je     @@c2
        cmp     al,@@compclr4
         je     @@c2
        dec     esi
@@movsb:
        mov     es:[edi],al
        inc     edi
        inc     esi
         jmp    @@start

@@nomoremushy:

        pop     ds

        mov     eax,edi
        les     edi,@@dest
        sub     eax,edi
        les     di,@@size
        mov     es:[di],ax

        ret
endp CompressLine_Mooishi

DeCompressLine_Mooishi proc far
arg @@src:pword,@@dest:pword,@@endofline:dword,@@clr1:byte,@@clr2:byte,@@clr3:byte,@@clr4:byte,@@size:dword

        push    ds

        lds     esi,@@src
        les     edi,@@dest
        xor     ecx,ecx
        mov     dl,@@clr1
        mov     dh,@@clr2
        mov     bl,@@clr3
        mov     bh,@@clr4

@@chewpizza:
	cmp	edi,@@endofline
	 jae	short @@nomoremushy

        mov     al,ds:[esi]
        inc     esi
	cmp	al,dl
	 je	short @@longstr
	cmp	al,dh
	 je	short @@shortstr
	cmp	al,bl
	 je	short @@checkstr
	cmp	al,bh
	 je	short @@checkshortstr
        mov     es:[edi],al
        inc     edi
	 jmp	short @@chewpizza
@@longstr:
        mov     cx,ds:[esi]
        mov     al,ds:[esi+2]
        add     esi,3
        mov     ah,al
        shr     cx,33
	db 67h
    rep	stosw
         jnc    short @@chewpizza
        db 67h
        stosb
	 jmp	short @@chewpizza
@@shortstr:
        mov     cl,ds:[esi]
        mov     al,ds:[esi+1]
        add     esi,2
        db 67h
    rep	stosb
	 jmp	short @@chewpizza
@@checkstr:
        mov     cx,ds:[esi]
        mov     ax,ds:[esi+2]
        add     esi,4
        db 67h
    rep	stosw
	 jmp	short @@chewpizza
@@checkshortstr:
	mov	cl,ds:[esi]
        mov     ax,ds:[esi+1]
        add     esi,3
        db 67h
    rep	stosw
	 jmp	short @@chewpizza

@@nomoremushy:
        pop     ds

        mov     eax,esi
        les     esi,@@src
        sub     eax,esi
        les     di,@@size
        mov     es:[di],ax

        ret
endp DeCompressLine_Mooishi

CompressLine_PCX proc far
arg @@src:pword,@@dest:pword,@@endofline:dword,@@size:dword

        push    ds
        lds     esi,@@src
        les     edi,@@dest
        mov     edx,@@endofline

@@start:cmp     esi,edx
         jae    short @@done
        mov     cx,1
        mov     al,ds:[esi]
@@check:inc     esi
        cmp     esi,edx
         jae    short @@bsetpix
        cmp     al,ds:[esi]
         jne    short @@bsetpix
        inc     cx
        cmp     cx,63
         jb     short @@check
        inc     esi
         jmp    short @@bsetpix2
@@bsetpix:
        cmp     al,0c0h
         jae    short @@bsetpix2
        cmp     cx,1
         je     short @@setpix
@@bsetpix2:
        add     cl,0c0h
        mov     es:[edi],cl
        inc     edi
@@setpix:
        mov     es:[edi],al
        inc     edi
         jmp    short @@start
@@done:
        pop     ds
        mov     eax,edi
        les     edi,@@dest
        sub     eax,edi
        les     di,@@size
        mov     es:[di],ax

        ret
endp CompressLine_PCX

DeCompressLine_PCX proc far
arg @@src:pword,@@dest:pword,@@endofline:dword,@@size:dword
        push    ds
        les     edi,@@dest
        lds     esi,@@src
        mov     edx,@@endofline
@@start:cmp     edi,edx
        jae     short @@done
        mov     al,ds:[esi]
        inc     esi
        cmp     al,0c0h
        jb      short @@foo
        mov     cl,al
        and     cl,3fh
        mov     al,ds:[esi]
        inc     esi
        mov     ah,al
        shr     cx,33
        db 67h
        rep     stosw
        jnc     short @@start
@@foo:  mov     es:[edi],al
        inc     edi
        jmp     short @@start
@@done:
        pop     ds
        mov     eax,esi
        les     esi,@@src
        sub     eax,esi
        les     di,@@size
        mov     es:[di],ax

        ret
endp DeCompressLine_PCX

DeCompressLine_PBM proc far
arg @@src:pword,@@dest:pword,@@endofline:dword,@@size:dword
        push    ds
        xor     ecx,ecx
        lds     esi,@@src
        les     edi,@@dest
        mov     edx,@@endofline
@@start:cmp     edi,edx
        jae     short @@done
        mov     al,ds:[esi]
        inc     esi
        cmp     al,127
        jbe      short @@moverun
        ; cx=0 at this point
        sub     cl,al
        inc     cx
        mov     al,ds:[esi]
        mov     ah,al
        inc     esi
        shr     cx,33
        db 67h
    rep stosw
        jnc     short @@start
        mov     es:[edi],al
        inc     edi
        jmp     short @@start
@@moverun:
        mov     cl,al
        inc     cx
        shr     cx,33
        db 67h
    rep movsw
        jnc     short @@start
        db 67h
        movsb
        jmp     short @@start

@@done:
        pop     ds

        mov     eax,esi
        les     esi,@@src
        sub     eax,esi
        les     di,@@size
        mov     es:[di],ax

        ret
DeCompressLine_PBM endp

DeCompressLine_IFF proc far
arg @@src:pword,@@dest:pword,@@endofline:dword,@@size:dword
        push    ds
        xor     ecx,ecx
        xor     eax,eax
        lds     esi,@@src
        les     edi,@@dest
        mov     bl,1
@@outer_loop:
        push    edi
@@start:cmp     edi,@@endofline
        jae     short @@do_next_bitplane
        mov     al,ds:[esi]
        inc     esi
        cmp     al,127
        jbe      short @@moverun
        ; cx=0 at this point
        sub     cl,al
        inc     cx
        mov     al,ds:[esi]
        inc     esi
        test    al,al                     ; if al=0 then no bits are set
        jnz     short @@sto_outer_loop
        shl     cx,3                     ; *8 (8 bits per pixel)
        add     edi,ecx                  ; skip past these bits/pixels)
        xor     cx,cx
        jmp     short @@start
@@sto_outer_loop:
        mov     dx,7
@@sto_inner_loop:
        bt      ax,dx
        jnc     short @@sto_noOr
        or      es:[edi],bl
@@sto_noOr:
        inc     edi
        dec     dx
        jns     short @@sto_inner_loop
        dec     cx
        jnz     short @@sto_outer_loop
        jmp     short @@start
@@moverun:
        mov     cl,al
        inc     cx

@@mov_outer_loop:
        mov     dx,7
        mov     al,ds:[esi]
        inc     esi
        test    al,al
        jnz     short @@mov_inner_loop
        add     edi,8
        jmp     short @@mov_next_byte
@@mov_inner_loop:
        bt      ax,dx
        jnc     short @@mov_noOr
        or      es:[edi],bl
@@mov_noOr:
        inc     edi
        dec     dx
        jns     short @@mov_inner_loop
@@mov_next_byte:
        dec     cx
        jnz     short @@mov_outer_loop
        jmp     short @@start
@@do_next_bitplane:
        pop     edi
        shl     bl,33
        jnc     short @@outer_loop
@@done:
        pop     ds

        mov     eax,esi
        les     esi,@@src
        sub     eax,esi
        les     di,@@size
        mov     es:[di],ax

        ret
DeCompressLine_IFF endp

Tgfx8@clear proc
arg @@colour:dword,@@self:dword

        les     si,@@self
        xor     ecx,ecx
        xor     edx,edx
        mov     al,byte ptr @@colour
        mov     ah,al
        push    ax
        push    ax
        pop     eax
        mov     edi,es:[si]._InternalOffset
        mov     bx,es:[si].GetMaxY
        mov     dx,es:[si].GetMaxX
        inc     bx
        inc     dx
        push    es:[si]._Data
        movzx   esi,es:[si].Xres
        sub     esi,edx
        pop     es

@@lop:  push    dx

        mov     cx,dx
        and     dx,3
        shr     cx,2
        db 67h
    rep stosd
        mov     cx,dx
        db 67h
    rep stosb
        pop     dx

;mov     cx,bx
;        shr     cx,33
;        db 67h
;        rep     stosw
;        jnc     @@noc
;        db 67h
;        stosb

@@noc:  add     edi,esi
        dec     bx
         jnz    short @@lop

        ret
Tgfx8@clear endp

TGfx8@FlipY proc far
arg @@self:dword
        push    ds
        xor     esi,esi
        les     si,@@self
        mov     dx,es:[si].GetMaxY
        inc     dx
        movzx   ebx,es:[si].Xres
        mov     ds,es:[si]._data
        mov     edi,es:[si]._InternalOffset
        mov     si,es:[si].GetMaxX
        add     esi,edi
@@lop:  push    esi edi
@@lop2: mov     al,ds:[edi]
        mov     ah,ds:[esi]
        mov     ds:[esi],al
        mov     ds:[edi],ah
        inc     edi
        dec     esi
        cmp     edi,esi
         jbe    short @@lop2
        pop     edi esi
        add     edi,ebx
        add     esi,ebx
        dec     dx
         jnz    short @@lop

        pop     ds
        ret
TGfx8@FlipY endp

TGfx8@HorizLine proc
arg @@x1:word,@@x2:word,@@y1:word,@@colour:dword,@@self:dword

        push    ds

        lds     si,@@self

        xor     ecx,ecx

        mov     ax,@@x1
        cmp     ax,@@x2
        jle     short @@noswap
        push    @@x2
        mov     @@x2,ax
        pop     @@x1
@@noswap:
        mov     ax,@@y1
        cmp     ax,ds:[si].GetMaxY  ; is the lineseg off the screen?
        ja      @@done

        mov     ax,@@x1
        mov     bx,@@x2

        mov     dx,ds:[si].GetMaxX

        cmp     ax,0
         jge    short @@checkMaxX
        mov     @@x1,0
        cmp     bx,0
         jl     @@done

@@checkMaxX:
        cmp     bx,dx   ; is the lineseg off the screen?
         jle    short @@GoOn
        mov     @@x2,dx
        cmp     ax,dx
        jg      @@done

@@GoOn:
        mov     cx,@@x2
        sub     cx,@@x1
        inc     cx

        mov     es,ds:[si]._data

        mov     bx,@@y1
        movzx   edi,@@x1
        shl     bx,2
        add     edi,ds:[si].LineOffsets[bx]
        add     edi,ds:[si]._internaloffset

        mov     al,byte ptr @@colour
        mov     ah,al
        push    ax
        push    ax
        pop     eax

        mov     dx,cx
        mov     cx,4
        sub     cx,di
        and     cx,3
        sub     dx,cx
        jle     short @@LEndBytes
        db 67h
        rep     stosb
        mov     cx,dx
        and     dx,3
        shr     cx,2
        db 67h
        rep     stosd
@@LEndBytes:
        add     cx,dx
        db 67h
        rep     stosb

@@done:
        pop     ds

        ret
endp TGfx8@HorizLine

filler proc far
ret
endp filler

TGfx8@GetImage proc
arg @@x1:word,@@y1:word,@@x2:word,@@y2:word,@@bitmap:pword,@@self:dword
local @@xres:dword
        push    ds

        mov     ax,@@x1
        cmp     ax,@@x2
        jb      short @@noswapx
        push    @@x2
        mov     @@x2,ax
        pop     @@x1
@@noswapx:
        mov     ax,@@y1
        cmp     ax,@@y2
        jb      short @@noswapy
        push    @@y2
        mov     @@y2,ax
        pop     @@y1
@@noswapy:

        lfs     di,@@self
        xor     eax,eax
        xor     ecx,ecx
        mov     ds,fs:[di]._data
        mov     ax,fs:[di].xres
        mov     @@xres,eax

        mov     bx,@@y1
        movzx   esi,@@x1
        shl     bx,2

        add     esi,fs:[di]._InternalOffset
        add     esi,fs:[di].LineOffsets[bx]

        les     edi,@@BitMap
        mov     ax,@@x2
        mov     bx,@@y2
        sub     ax,@@x1
        sub     bx,@@y1
        inc     ax
        inc     bx

        mov     es:[edi],ax
        mov     es:[edi+2],bx
        add     edi,4

@@lop:  push    esi

        mov     edx,eax
        mov     cx,4
        sub     cx,di
        and     cx,3
        sub     dx,cx
        jle     short @@LEndBytes
        db 67h
    rep movsb
        mov     cx,dx
        and     dx,3
        shr     cx,2
        db 67h
    rep movsd
@@LEndBytes:
        add     cx,dx
        db 67h
    rep movsb

        pop     esi
        add     esi,@@xres
        dec     bx
        jnz     short @@lop

        pop     ds
        ret
Tgfx8@GetImage endp

Tgfx8@getpixel proc far
arg @@x:word,@@y:word,@@self:dword
        les     si,@@self
        mov     eax,TransparentColour
        shld    edx,eax,16
        mov     bx,@@y
        cmp     bx,es:[si].GetMaxY
        ja      short @@NoGetPix
        movzx   edi,@@x
        cmp     di,es:[si].GetMaxX
        ja      short @@noGetPix
        shl     bx,2

        add     edi,es:[si].LineOffsets[bx]
        add     edi,es:[si]._InternalOffset
        mov     es,es:[si]._data
        mov     al,es:[edi]
@@NoGetPix:
        ret
Tgfx8@getpixel endp

TGfx8@Putimage proc
arg @@x:word,@@y:word,@@bitmap:pword,@@self:dword
local @@xres:dword,@@sourceAdd:dword,@@destAdd:dword,@@RealWidth:dword
;local @@CopyWidth:dword,@@CopyHeight:word

        push    ds
        xor     eax,eax
        lfs     si,@@self
        mov     ax,fs:[si].xres
        mov     es,fs:[si]._data
        mov     @@xres,eax

        mov     bx,@@y
        movzx   edi,@@x
        shl     bx,2
        add     edi,fs:[si]._InternalOffset
        add     edi,fs:[si].LineOffsets[bx]

        lds     esi,@@bitmap
        mov     ax,ds:[esi]   ;
        mov     bx,ds:[esi+2]  ; height
        add     esi,4

@@lop:  push    edi

        mov     edx,eax
        mov     cx,4
        sub     cx,di
        and     cx,3
        sub     dx,cx
        jle     short @@LEndBytes
        db 67h
    rep movsb
        mov     cx,dx
        and     dx,3
        shr     cx,2
        db 67h
    rep movsd
@@LEndBytes:
        add     cx,dx
        db 67h
    rep movsb
        pop     edi
        add     edi,@@xres
        dec     bx
        jnz     short @@lop
        pop     ds
        ret
TGfx8@Putimage endp

TGfx8@PutBlit proc
arg @@x:word,@@y:word,@@blit:pword,@@self:dword
local @@xres:dword,@@getmaxx:word,@@getmaxy:word
        push    ds

        cmp     word ptr @@blit+4,0
        jne     short @@BlitSegNotEmpty
        cmp     dword ptr @@blit,0
        je      @@exit
@@BlitSegNotEmpty:

        lds     si,@@self
        push    ds
        pop     fs
        xor     edx,edx
        xor     ebx,ebx
        xor     ecx,ecx
        xor     eax,eax
        mov     ax,ds:[si].GetMaxX
        mov     @@GetMaxX,ax
        mov     ax,ds:[si].GetMaxY
        mov     @@GetMaxY,ax
        mov     dx,ds:[si].xres
        mov     @@xres,edx
        lds     edi,@@blit

        mov     ax,@@x
        mov     bx,@@y
        mov     cx,ax
        mov     dx,bx
;        add     ax,ds:[edi]       ; ax=@@x+x1
;        add     bx,ds:[edi+2]     ; bx=@@y+y1
        add     cx,ds:[edi+4]     ; cx=@@x+x2
        add     dx,ds:[edi+6]     ; dx=@@y+y2

        cmp     cx,0          ; is the right edge off the screen?
        jl      @@exit
        cmp     dx,0          ; is the bottom edge off the screen?
        jl      @@exit
        cmp     ax,@@GetMaxX  ; is the left edge off the screen?
        jg      @@exit
        cmp     bx,@@GetMaxY  ; is the top edge off the screen?
        jg      @@exit

;{-------------Part or all of blit is on the screen-----------------------}
        mov     es,fs:[si]._data

        lea     di,@@dflt

        cmp     ax,0
        jge     short @@chkx2 ; is the left edge overlapping?
        sub     di,4
        jmp     short @@chky1
@@chkx2:cmp     cx,@@GetMaxX  ; is the right edge overlapping?
        jl      short @@chky1
        add     di,4

@@chky1:cmp     bx,0          ; is the top edge overlapping?
        jge     short @@chky2
        sub     di,4*3
        jmp     short @@jumpit
@@chky2:cmp     dx,@@GetMaxY  ; is the bottom edge overlapping?
        jl      short @@jumpit
        add     di,4*3
@@jumpit:

        jmp     di

        jmp     ShowUl
        nop
        jmp     ShowTop
        nop
        jmp     ShowUR
        nop
        jmp     ShowLeft
        nop
@@dflt: jmp     ShowMiddle
        nop
        jmp     ShowRight
        nop
        jmp     ShowLL
        nop
        jmp     ShowBottom
        nop
        jmp     ShowLR
        nop
        jmp     @@exit
showUL:
        xor     bx,bx ; start at y=0
        movsx   edi,@@x
        add     edi,fs:[si].LineOffsets[bx]
        add     edi,fs:[si]._InternalOffset

        lds     esi,@@blit
        add     esi,8
        mov     dx,ds:[esi]
        sub     bx,@@y    ; 0-@@y
        shr     dx,33
        shl     bx,33     ; *2
        test    dx,dx
        jz      @@exit
        add     si,ds:[esi+ebx]  ; seek into the blit
        add     dx,@@y
        xor     bx,bx
        jmp     @@SLyloop
showtop:
        xor     bx,bx ; start at y=0
        movzx   edi,@@x
        add     edi,fs:[si].LineOffsets[bx]
        add     edi,fs:[si]._InternalOffset

        lds     esi,@@blit
        add     esi,8
        mov     dx,ds:[esi]
        sub     bx,@@y    ; 0-@@y
        shr     dx,33
        shl     bx,33     ; *2
        test    dx,dx
        jz      @@exit
        add     si,ds:[esi+ebx]  ; seek into the blit
        add     dx,@@y
        xor     bx,bx  ; bx is 0 as set above
        jmp     @@SMyloop
showUR:
        xor     bx,bx ; start at y=0
        movzx   edi,@@x
        add     edi,fs:[si].LineOffsets[bx]
        add     edi,fs:[si]._InternalOffset

        lds     esi,@@blit
        add     esi,8
        mov     dx,ds:[esi]
        sub     bx,@@y    ; 0-@@y
        shr     dx,33
        shl     bx,33     ; *2     ; bx==0
        test    dx,dx
        jz      @@exit
        add     si,ds:[esi+ebx]  ; seek into the blit
        add     dx,@@y
        xor     bx,bx  ; bx is 0 as set above.. bx had better be 0..
        jmp     @@SRyloop
showleft:
        mov     bx,@@y
        movsx   edi,@@x   ; X will be negative
        shl     bx,2
        add     edi,fs:[si].LineOffsets[bx]
        add     edi,fs:[si]._InternalOffset

        lds     esi,@@blit
        add     esi,8
        mov     dx,ds:[esi]
        add     esi,edx
        shr     dx,33
        test    dx,dx
        jz      @@exit
        xor     bx,bx
@@SLyloop:
        mov     bl,ds:[esi]   ; linecount
        inc     esi
        test    bx,bx
        jz      short @@SLnoxLloop

        push    dx
        push    edi
        mov     dx,@@x
        neg     dx
@@SLxloop:
        mov     ax,ds:[esi] ; offset
        add     edi,eax
        mov     cx,ds:[esi+2]
        sub     dx,ax
        jc      short @@SLfakeloop
        add     esi,4
        sub     dx,cx
        jc      short @@SLedge_overlap
        add     esi,ecx
        add     edi,ecx
        dec     bx
        jnz     short @@SLxloop
@@SLresume:
        pop     edi
        pop     dx
@@SLnoxLloop:
        add     edi,@@xres
        dec     dx
        jnz     short @@SLyloop
        jmp     @@exit

@@SLedge_overlap:
        add     dx,cx
        sub     cx,dx
        add     esi,edx
        add     edi,edx
        shr     ecx,33
        db 67h
    rep movsw
        jnc     short @@SLnoc
        db 67h
        movsb
@@SLnoc:
        dec     bx
        jz      short @@SLresume
@@SLfakeloopstart:
        mov     ax,ds:[esi]     ; offset
        add     edi,eax         ; add the offset to the dest
        mov     cx,ds:[esi+2]   ; pix_count
@@SLfakeloop:
        add     esi,4           ; adjust source pointer
        shr     ecx,33
        db 67h
    rep movsw
        jnc     short @@SLnoc2
        db 67h
        movsb
@@SLnoc2:
        dec     bx
        jnz     short @@SLfakeloopstart
        jmp     short @@SLresume
ShowMiddle:
        mov     bx,@@y
        movzx   edi,@@x            ; edi=@@x
        shl     bx,2
        add     edi,fs:[si].LineOffsets[bx]   ;edi=@@x+@@y*xres
        add     edi,fs:[si]._InternalOffset

        lds     esi,@@blit
        add     esi,8
        mov     dx,ds:[esi]
        add     esi,edx
        shr     dx,33
        test    dx,dx
        jz      short @@exit
        xor     bx,bx
@@SMyloop:
        mov     bl,byte ptr ds:[esi]   ; linecount
        inc     esi
        test    bx,bx
        jz      short @@SMnoxLloop
        push    edi
@@SMxloop:
        mov     ax,ds:[esi]     ; offset
        add     edi,eax         ; add the offset to the dest
        mov     ax,ds:[esi+2]   ; pix_count
        add     esi,4           ; adjust source pointer

        mov     cx,4
        sub     cx,di
        and     cx,3
        sub     ax,cx
        jle     short @@SMEndBytes
        db 67h
    rep movsb
        mov     cx,ax
        and     ax,3
        shr     cx,2
        db 67h
    rep movsd
@@SMEndBytes:
        add     cx,ax
        db 67h
    rep movsb

        dec     bx
        jnz     short @@SMxloop
        pop     edi
@@SMnoxLloop:

        add     edi,@@xres
        dec     dx
        jnz     short @@SMyloop
@@exit:
        pop     ds
        ret
showright:
        mov     bx,@@y
        movzx   edi,@@x
        shl     bx,2
        add     edi,fs:[si].LineOffsets[bx]
        add     edi,fs:[si]._InternalOffset

        lds     esi,@@blit
        add     esi,8
        mov     dx,ds:[esi]
        add     esi,edx
        shr     dx,33
        test    dx,dx
        jz      short @@exit
        xor     bx,bx
@@SRyloop:
        mov     bl,byte ptr ds:[esi]   ; linecount
        inc     esi
        test    bx,bx
        jz      short @@SRnoxLloop

        push    dx
        push    edi
        mov     dx,@@GetMaxX
        sub     dx,@@X
        inc     dx
@@SRxloop:
        mov     ax,ds:[esi] ; offset
        sub     dx,ax
        js      short @@SRfakeloop
        add     edi,eax
        mov     cx,ds:[esi+2]
        add     esi,4
        sub     dx,cx
        js      short @@SRedge_overlap

        mov     ax,cx
        mov     cx,4
        sub     cx,di
        and     cx,3
        sub     ax,cx
        jle     short @@SREndBytes
        db 67h
    rep movsb
        mov     cx,ax
        and     ax,3
        shr     cx,2
        db 67h
    rep movsd
@@SREndBytes:
        add     cx,ax
        db 67h
    rep movsb
        dec     bx
        jnz     short @@SRxloop
@@SRresume:
        pop     edi
        pop     dx

@@SRnoxLloop:
        add     edi,@@xres
        dec     dx
        jnz     short @@SRyloop
        jmp     @@exit
@@SRedge_overlap:
        add     dx,cx   ; dx=dist to edge; cx=total count
        xchg    dx,cx   ; cx=dist to edge; dx=total count
        sub     dx,cx   ; adjust end pointer
        db 67h
        rep     movsb
        add     esi,edx
        jmp     short @@SRfake_loop_dec_bx
@@SRFakeLoop:
        mov     cx,ds:[esi+2]
        add     esi,4
        add     esi,ecx
@@SrFake_loop_dec_bx:
        dec     bx
        jnz     short @@SRFakeLoop
        jmp     short @@SRresume

showLL:
        mov     bx,@@y
        movsx   edi,@@x
        shl     bx,2
        add     edi,fs:[si].LineOffsets[bx]
        add     edi,fs:[si]._InternalOffset

        lds     esi,@@blit ; load blit pointer
        add     esi,8
        mov     dx,ds:[esi]
        add     esi,edx
        shr     dx,33
        test    dx,dx
        jz      @@exit
        mov     dx,@@GetMaxY
        sub     dx,@@y
        inc     dx
        xor     bx,bx
        jmp     @@SLyloop
ShowBottom:
        mov     bx,@@y
        movzx   edi,@@x
        shl     bx,2
        add     edi,fs:[si].LineOffsets[bx]
        add     edi,fs:[si]._InternalOffset

        lds     esi,@@blit ; load blit pointer
        add     esi,8
        mov     dx,ds:[esi]
        add     esi,edx
        shr     dx,33
        test    dx,dx
        jz      @@exit
        mov     dx,@@GetMaxY
        sub     dx,@@y
        inc     dx
        xor     bx,bx
        jmp     @@SMyloop
showLR:
        mov     bx,@@y
        movzx   edi,@@x
        shl     bx,2
        add     edi,fs:[si].LineOffsets[bx]
        add     edi,fs:[si]._InternalOffset

        lds     esi,@@blit          ; load blit pointer
        add     esi,8               ; skip past bounds table
        mov     dx,ds:[esi]
        add     esi,edx
        shr     dx,33
        test    dx,dx
        jz      @@exit
        mov     dx,@@GetMaxY
        sub     dx,@@y
        xor     bx,bx
        inc     dx
        jmp     @@SRyloop
TGfx8@PutBlit endp

TGfx8@PutPixel proc far
arg @@x:word,@@y:word,@@colour:dword,@@self:dword
        les     si,@@self          ; es:[si] -> self
        mov     bx,@@y
        cmp     bx,es:[si].GetMaxY ; check to see if 0<=@@y<=GetMaxY
         ja     short @@NoPutPix
        movzx   edi,@@x            ; edi=@@x
        cmp     di,es:[si].GetMaxX ; check to see if 0<=@@x<=GetMaxX
         ja     short @@NoPutPix

        shl     bx,2
        mov     al,byte ptr @@colour
        add     edi,es:[si].LineOffsets[bx]   ;edi=@@x+@@y*xres
        add     edi,es:[si]._InternalOffset
        mov     es,es:[si]._data
        mov     es:[edi],al
@@NoPutPix:
        ret
Tgfx8@PutPixel endp

TGfx8@RawLine proc
arg @@x1:word,@@y1:word,@@x2:word,@@y2:word,@@colour:dword,@@self:dword
local @@tc:word,@@xres:dword

        push    ds
        lds     si,@@self
        mov     es,ds:[si]._Data
        movzx   eax,ds:[si].Xres
        mov     @@xres,eax

        mov     bx,@@y1
        shl     bx,2
        mov     edi,ds:[si].LineOffsets[bx]
        mov     edx,ds:[si]._InternalOffset
        movzx   eax,@@x1
        add     edi,eax
        add     edi,edx

        mov     bx,@@Y2
        shl     bx,2
        mov     esi,ds:[si].LineOffsets[bx]
        movzx   eax,@@x2
        add     esi,eax
        add     esi,edx

        mov     ax,@@x2
        mov     bx,@@y2
        sub     ax,@@x1
        sub     bx,@@y1
        mov     ecx,1
        mov     edx,@@Xres
        bt      ax,15
         jnc    short @@xpositive
        or      ecx,-1             ;{this is faster than moving -1 into ecx}
        neg     ax
@@xpositive:
        add     ax,ax
         bt     bx,15
        jnc     short @@ypositive
        mov     edx,@@xres
        neg     edx
        neg     bx
@@ypositive:
        add     bx,bx

        cmp     ax,bx
         jle    short @@ygreater
        push    cx
        mov     cx,ax
        mov     @@tc,bx
        shr     cx,33
        sub     @@tc,cx
        pop     cx
@@xtop:
        push    eax
        mov     al,byte ptr @@colour
        mov     es:[edi],al
        pop     eax
        cmp     esi,edi
         je     short @@done
        cmp     @@tc,0
         jl     short @@noaddy
        add     edi,edx
        sub     @@tc,ax
@@noaddy:
        add     edi,ecx
        add     @@tc,bx

         jmp    short @@xtop

@@ygreater:
        push    cx
        mov     cx,bx
        mov     @@tc,ax
        shr     cx,33
        sub     @@tc,cx
        pop     cx

@@ytop: push    eax
        mov     al,byte ptr @@colour
        mov     es:[edi],al
        pop     eax
        cmp     esi,edi
        je      short @@done
        cmp     @@tc,0
        jl      short @@noaddx
        add     edi,ecx
        sub     @@tc,bx
@@noaddx:
        add     edi,edx
        add     @@tc,ax
        jmp     short @@ytop
@@done: pop     ds

        ret
TGfx8@RawLine endp

TGfx8@ScaleBuf proc
arg @@dX1:word,@@dY1:word,@@dX2:word,@@dY2:word,@@SrcObject:dword,@@sx1:word,@@sy1:word,@@sx2:word,@@sy2:word,@@self:dword
local @@xres:dword,@@xinc:dword,@@yinc:dword

        mov     ax,@@sx1
        cmp     ax,@@sx2
        jb      short @@noswapsx
        push    @@sx2
        mov     @@sx2,ax
        pop     @@sx1
@@noswapsx:
        mov     ax,@@sy1
        cmp     ax,@@sy2
        jb      short @@noswapsy
        push    @@sy2
        mov     @@sy2,ax
        pop     @@sy1
@@noswapsy:

        mov     ax,@@dx1
        cmp     ax,@@dx2
        jb      short @@noswapdx
        push    @@dx2
        mov     @@dx2,ax
        pop     @@dx1
@@noswapdx:
        mov     ax,@@dy1
        cmp     ax,@@dy2
        jb      short @@noswapdy
        push    @@dy2
        mov     @@dy2,ax
        pop     @@dy1
@@noswapdy:

        mov     ax,@@dx2
        sub     ax,@@dx1
        inc     ax

        cmp     ax,0
        jle     @@nomoreloops

        xor     dx,dx
        push    dx
        push    ax
        mov     ax,@@sx2
        sub     ax,@@sx1
        inc     ax
        xor     dx,dx
        mov     cx,16
        xor     bx,bx
        call    @@mulsetup
        pop     cx
        pop     bx
        call    @@mul
        mov     word ptr @@xinc,ax
        mov     word ptr @@xinc+2,dx


        mov     ax,@@dy2
        sub     ax,@@dy1
        inc     ax

        cmp     ax,0
        jle     @@nomoreloops

        xor     dx,dx
        push    dx
        push    ax
        mov     ax,@@sy2
        sub     ax,@@sy1
        inc     ax
        xor     dx,dx
        mov     cx,16
        xor     bx,bx
        call    @@mulsetup
        pop     cx
        pop     bx
        call    @@mul
        mov     word ptr @@yinc,ax
        mov     word ptr @@yinc+2,dx

        cmp     @@dx1,0
        jge     short @@dx1InRange
        mov     @@dx1,0
@@dx1InRange:

        cmp     @@dy1,0
        jge     short @@dy1InRange
        mov     @@dy1,0
@@dy1InRange:

        push    ds

        lds     si,@@self

        mov     ax,ds:[si].GetMaxX

        cmp     @@dx2,ax
        jl      short @@dx2inrange
        mov     @@dx2,ax
@@dx2inrange:

        mov     ax,ds:[si].GetMaxY
        cmp     @@dy2,ax
        jl      short @@dy2InRange
        mov     @@dy2,ax
@@dy2InRange:

        push    ds
        pop     fs

        mov     bx,@@dy1
        movzx   edi,@@dx1
        shl     bx,2
        add     edi,ds:[si].LineOffsets[bx] ; edi=dy1*xres+dx1
        add     edi,ds:[si]._InternalOffset

        mov     es,ds:[si]._data

        movzx   eax,ds:[si].xres
        mov     @@Xres,eax

        mov     ax,@@dX1
        dec     ax          ; because (a-b)+1 is equal to a-(b-1)
        sub     @@dx2,ax    ; {@@dx2 is now width}

        mov     ax,@@dY1
        dec     ax
        sub     @@dy2,ax    ; {@@dy2 is now height}

        lgs     si,@@SrcObject

        mov     ds,gs:[si]._data

        movzx   ebx,@@sy1
        shl     ebx,16

@@mainloop:
        push    edi

        push    ebx

        mov     si,word ptr @@SrcObject
        movzx   edx,@@sx1
        shr     ebx,16
        shl     bx,2
        add     edx,gs:[si].LineOffsets[bx]
        add     edx,gs:[si]._InternalOffset
        mov     esi,edx

        xor     ecx,ecx
        mov     bx,@@dx2
        push    ebp
        mov     ebp,@@xinc
@@innerloop:
        add     ecx,ebp
        mov     al,ds:[esi]
        mov     esi,ecx
        shr     esi,16
        add     esi,edx
        mov     es:[edi],al
        inc     edi
        dec     bx
        jnz     short @@innerloop
        pop     ebp

@@nextline:

        pop     ebx
        pop     edi
        add     ebx,@@yinc
        add     edi,@@xres

        dec     @@dy2
        jnz     @@mainloop

@@nomoreloops:

        pop     ds
        ret

@@mulsetup:
        shl     edx,16
        mov     dx,ax
        shl     edx,cl
        mov     ax,dx
        shr     edx,16
        retn
@@mul:
        shl     eax,16
        shrd    eax,edx,16
        shl     ecx,16
        shrd    ecx,ebx,16
        cdq
        idiv    ecx
        mov     ecx,edx
        shld    edx,eax,16
        shld    ebx,ecx,16
        retn
endp TGfx8@ScaleBuf

TGfx8@Vertline proc
arg @@x:word,@@y1:word,@@y2:word,@@colour:dword ,@@self:dword;

        push    ds

        lds     si,@@self

        mov     ax,@@y1
        cmp     ax,@@y2
        jle     short @@noswap
        push    @@y2
        mov     @@y2,ax
        pop     @@y1
@@noswap:
        mov     ax,@@x
        cmp     ax,ds:[si].GetMaxX  ; is the lineseg off the screen?
        ja      short @@done

        mov     ax,@@y1
        mov     bx,@@y2
        mov     dx,ds:[si].GetMaxY

        cmp     ax,0
        jge     short @@checkMaxY
        mov     @@y1,0
        cmp     bx,0
        jl      short @@done

@@checkMaxY:

        cmp     bx,dx   ; is the lineseg off the screen?
        jle     short @@GoOn
        mov     @@y2,dx
        cmp     ax,dx
        jg      short @@done
@@GoOn:
        mov     es,ds:[si]._data

        mov     bx,@@y1
        movzx   edi,@@x
        shl     bx,2
        add     edi,ds:[si].LineOffsets[bx]
        add     edi,ds:[si]._InternalOffset

        movzx   ebx,ds:[si].Xres
        mov     cx,@@y2
        sub     cx,@@y1
        inc     cx

        mov     al,byte ptr @@colour

@@lop:  mov     es:[edi],al
        add     edi,ebx
        dec     cx
        jnz     short @@lop
@@done:
        pop     ds
        ret
endp TGfx8@Vertline





;=========================================================================

;{==============================vvvvvvvvvvvvvvv=============================}
;{==========================>  TSCreen8.CLEAR <=============================}
;{==============================^^^^^^^^^^^^^^^=============================}

TScreen8@clear proc
arg @@colour:dword,@@self:dword
        push    ds
        lds     si,@@self

        cmp     ds:[si]._LFB,FALSE
        je      short @@NoLFB
        pop     ds
        push    dword ptr @@colour
        push    @@self
        call    TGfx8@Clear
        ret
@@NoLFB:
        movzx   eax,ds:[si].xres
        mul     ds:[si].yres
        mov     al,byte ptr @@colour
        mov     ah,al
        push    ax
        push    ax
        pop     eax
        mov     es,ds:[si]._data
        xor     di,di
@@lop:  push    dx
        push    ax

        mov     bx,dx
        add     bx,bx
        mov     dx,ds:[si]._BankVals[bx]
        xor     bx,bx
        call    dword ptr ds:[si].SwitchBank

        pop     ax

        mov     cx,16384
        rep     stosd
        pop     dx
        dec     dx
        jns     short @@lop

        mov     ds:[si]._CurWriteBank,0
        mov     ax,ds:[si]._ReadWindow
        test    ax,ax
        jnz     short @@done
        mov     ds:[si]._CurReadBank,0
@@done:
        pop     ds

        ret
TScreen8@clear endp

TScreen8@CopyLineFromScreen proc
arg @@x:word,@@y:word,@@dest:pword,@@size:word,@@self:dword
        push    ds

        lfs     di,@@self

        cmp     fs:[di]._LFB,TRUE
         je     @@DiffBank

        mov     bx,@@y
        movzx   esi,@@x
        shl     bx,2
        add     esi,fs:[di].LineOffsets[bx] ; esi=y*xres+x

        mov     ds,fs:[di]._data

        shld    ebx,esi,16

        cmp     bx,fs:[di]._CurReadBank
         je     short @@copyline

;   { change page; call VESA }
        mov     fs:[di]._CurReadBank,bx  ; { reset to new page }
        add     bx,bx
        mov     dx,fs:[di]._BankVals[bx]
        mov     bx,fs:[di]._ReadWindow
        call    fs:[di].dword ptr switchbank
@@copyline:

        les     edi,pword ptr @@dest
        and     esi,0ffffh
        movzx   ecx,@@size
        mov     ax,si
        add     ax,cx
        jc      short @@splitbank

        mov     bx,cx
        and     bx,3
        shr     cx,2
        db 67h
    rep movsd
        mov     cx,bx
        db 67h
    rep movsb
        jmp     short @@nomore
@@splitbank:
        mov     dx,cx
        xor     cx,cx
        sub     cx,si
        sub     dx,cx

        mov     bx,cx
        and     bx,3
        shr     cx,2
        db 67h
    rep movsd
        mov     cx,bx
        db 67h
    rep movsb
        push    dx di

        mov     di,word ptr @@self
        inc     fs:[di]._CurReadBank
        mov     bx,fs:[di]._CurReadBank
        add     bx,bx
        mov     dx,fs:[di]._BankVals[bx]
        mov     bx,fs:[di]._ReadWindow
        call    fs:[di].dword ptr SwitchBank

        pop     di dx

        and     esi,0ffffh
        mov     cx,dx
        shr     cx,33
        db 67h
    rep movsw
         jnc    short @@nomore
        db 67h
        movsb

@@nomore:
        mov     di,word ptr @@self
        mov     ax,fs:[di]._ReadWindow
        test    ax,ax
         jnz    short @@DiffBank
        mov     ax,fs:[di]._CurReadBank
        mov     fs:[di]._CurWriteBank,ax
@@DiffBank:
        pop     ds
        ret
endp TScreen8@CopyLineFromScreen

TScreen8@CopyLineToScreen proc
arg @@source:pword,@@x:word,@@y:word,@@size:word,@@self:dword

        push    ds

        lfs     si,@@self

        cmp     fs:[si]._LFB,TRUE
        je      @@DiffBank

        mov     bx,@@y
        movzx   edi,@@x
        shl     bx,2
        add     edi,fs:[si].LineOffsets[bx] ; edi=y*xres+x

        mov     es,fs:[si]._data

        shld    ebx,edi,16

        cmp     bx,fs:[si]._CurWriteBank
         je     short @@copyline

;   { change page; call VESA }
        mov     fs:[si]._CurWriteBank,bx  ; { reset to new page }
        add     bx,bx
        mov     dx,fs:[si]._BankVals[bx]
        xor     bx,bx
        call    fs:[si].dword ptr switchbank
@@copyline:

        lds     esi,pword ptr @@source
        and     edi,0ffffh
        movzx   ecx,@@size
        mov     ax,di
        mov     dx,cx
        add     ax,cx
         jnc    short @@Nosplitbank

        xor     cx,cx
        sub     cx,di
        sub     dx,cx

        mov     bx,cx
        and     bx,3
        shr     cx,2
        db 67h
    rep movsd
        mov     cx,bx
        db 67h
    rep movsb
        push    dx si

        mov     si,word ptr @@self
        inc     fs:[si]._CurWriteBank
        mov     bx,fs:[si]._CurWriteBank
        add     bx,bx
        mov     dx,fs:[si]._BankVals[bx]
        xor     bx,bx
        call    fs:[si].dword ptr SwitchBank

        pop     si dx

        and     edi,0ffffh
        mov     cx,dx
@@NoSplitBank:
        mov     cx,4
        sub     cx,di
        and     cx,3
        sub     dx,cx
         jle    short @@LEndBytes
        db 67h
    rep movsb
        mov     cx,dx
        and     dx,3
        shr     cx,2
        db 67h
    rep movsd
@@LEndBytes:
        add     cx,dx
        db 67h
        rep     movsb

@@nomore:
        mov     si,word ptr @@self
        mov     ax,fs:[si]._ReadWindow
        test    ax,ax
        jnz     short @@DiffBank
        mov     ax,fs:[si]._CurWriteBank
        mov     fs:[si]._CurReadBank,ax
@@DiffBank:

        pop     ds
        ret
endp TScreen8@CopyLineToScreen

TScreen8@GetImage proc
arg @@x1:word,@@y1:word,@@x2:word,@@y2:word,@@bitmap:pword,@@self:dword
local @@xcount:word,@@ycount:word,@@xres:word

        les     di,@@self
        cmp     es:[di]._LFB,FALSE
        je      short @@NoLFB
        push    @@x1
        push    @@y1
        push    @@x2
        push    @@y2
        push    @@BitMap
        push    @@Self
        call    TGfx8@GetImage
        ret
@@NoLFB:
        push    ds

        xor     ecx,ecx
        mov     ax,@@x1
        cmp     ax,@@x2
        jb      short @@noswapx
        push    @@x2
        mov     @@x2,ax
        pop     @@x1
@@noswapx:
        mov     ax,@@y1
        cmp     ax,@@y2
        jb      short @@noswapy
        push    @@y2
        mov     @@y2,ax
        pop     @@y1
@@noswapy:

        mov     ax,@@y2
        mov     @@ycount,ax
        mov     ax,@@y1
        sub     @@ycount,ax
        inc     @@ycount       ;{@@ycount=@@y2-@@y1+1}

        mov     ax,@@x2
        mov     @@xcount,ax
        mov     ax,@@x1
        sub     @@xcount,ax
        inc     @@xcount       ;{@@xcount=@@x2-@@x1+1}

        lfs     di,@@self

        mov     ax,fs:[di].xres
        mov     @@xres,ax
        mov     ds,fs:[di]._data

        mov     bx,@@y1
        shl     bx,2
        mov     esi,fs:[di].LineOffsets[bx]
        mov     cx,@@x2
        add     cx,si
        movzx   eax,@@x1
        add     esi,eax
        shld    ebx,esi,16
        and     esi,0ffffh
        cmp     bx,fs:[di]._CurReadBank
        je      short @@getim

;   { change page; call VESA }
        mov     fs:[di]._CurReadBank,bx  ; { reset to new page }
        add     bx,bx
        mov     dx,fs:[di]._BankVals[bx]
        mov     bx,fs:[di]._ReadWindow
        call    fs:[di].dword ptr switchbank

@@getim:
        les     edi,@@bitmap
        mov     ax,@@xcount
        mov     es:[edi],ax
        mov     ax,@@ycount
        mov     es:[edi+2],ax
        add     edi,4

        mov     bx,cx
@@top:  push    si
        cmp     bx,si
        jb      short @@CopySplitBank

        mov     cx,@@xCount

        mov     dx,cx
        and     dx,3
        shr     cx,2
        db 67h
        rep     movsd
        mov     cx,dx
        db 67h
        rep     movsb

@@dropline:
        add     bx,@@xres
        pop     si
        add     si,@@xres
        jc      short @@BankChange
@@GoBack:
        dec     @@yCount
        jnz     short @@top

        pop     ds

        lfs     si,@@self
        mov     ax,fs:[si]._ReadWindow
        test    ax,ax
        jnz     short @@noswitch
        mov     ax,fs:[si]._CurReadBank
        mov     fs:[si]._CurWriteBank,ax
@@noswitch:
        ret

@@CopySplitBank:

        push    bx

        xor     cx,cx
        sub     cx,si
        mov     dx,cx

        mov     bx,cx
        and     bx,3
        shr     cx,2
        db 67h
        rep     movsd
        mov     cx,bx
        db 67h
        rep     movsb

        mov     cx,@@xCount
        sub     cx,dx

        push    si

        mov     si,word ptr @@self
        inc     fs:[si]._CurReadBank
        mov     bx,fs:[si]._CurReadBank
        add     bx,bx
        mov     dx,fs:[si]._BankVals[bx]
        mov     bx,fs:[si]._ReadWindow
        call    dword ptr fs:[si].SwitchBank

        pop     si

        and     esi,0ffffh
        pop     bx

        shr     cx,33
        db 67h
        rep     movsw
        adc     cx,cx
        db 67h
        rep     movsb

        pop     si
        add     bx,@@xres
        add     si,@@xres
        jmp     short @@GoBack

@@BankChange:
        push    bx
        push    di
        mov     di,word ptr @@self
        xor     dx,dx
        inc     fs:[di]._CurReadBank
        mov     bx,fs:[di]._CurReadBank
        add     bx,bx
        mov     dx,fs:[di]._BankVals[bx]
        mov     bx,fs:[di]._ReadWindow
        call    dword ptr fs:[di].SwitchBank
        pop     di
        and     esi,0ffffh
        pop     bx
        jmp     @@GoBack
endp TScreen8@GetImage

TScreen8@getpixel proc
arg @@x:word,@@y:word,@@self:dword

        les     si,@@self

        cmp     es:[si]._LFB,FALSE
         je     short @@NoLFB
        push    @@x
        push    @@y
        push    @@self
        call    TGfx8@GetPixel
        ret
@@NoLfb:

        mov     eax,TransparentColour
        shld    edx,eax,16

        mov     bx,@@y
        cmp     bx,es:[si].GetMaxY
         ja     short @@NoReadPix
        movzx   edi,@@x
        cmp     di,es:[si].GetMaxX
         ja     short @@NoReadPix

        shl     bx,2
        add     edi,es:[si].LineOffsets[bx]

        shld    ebx,edi,16

        cmp     bx,es:[si]._CurReadBank
         je     short @@readpix

        mov     es:[si]._CurReadBank,bx  ; { reset to new page }
        add     bx,bx
        mov     dx,es:[si]._BankVals[bx]
        mov     bx,es:[si]._ReadWindow
        call    dword ptr es:[si].SwitchBank

        mov     ax,es:[si]._ReadWindow
        test    ax,ax
         jnz    short @@readpix
        mov     ax,es:[si]._CurReadBank
        mov     es:[si]._CurWriteBank,ax

@@readpix:
        mov     es,es:[si]._data
        mov     al,es:[di]
@@noReadPix:
        ret
TScreen8@getpixel endp

TScreen8@horizline proc
arg @@x1:word,@@x2:word,@@y1:word,@@colour:dword,@@self:dword

        push    ds

        lds     si,@@self
        cmp     ds:[si]._LFB,FALSE
        je      short @@NoLFB
        pop     ds
        push    @@x1
        push    @@x2
        push    @@y1
        push    @@colour
        push    @@self
        call    TGfx8@HorizLine
        ret
@@NoLFB:
        xor     ecx,ecx
        mov     ax,@@x1
        cmp     ax,@@x2
        jle     short @@noswap
        push    @@x2
        mov     @@x2,ax
        pop     @@x1
@@noswap:
        mov     ax,@@y1
        cmp     ax,ds:[si].GetMaxY  ; is the lineseg off the screen?
        ja      @@done

        mov     ax,@@x1
        mov     bx,@@x2
        mov     dx,ds:[si].GetMaxX

        cmp     ax,0
        jge     @@checkMaxX
        cmp     bx,0
        jl      @@done
        mov     @@x1,0

@@checkMaxX:
        cmp     bx,dx   ; is the lineseg off the screen?
        jle     @@GoOn
        cmp     ax,dx
        jg      @@done
        mov     @@x2,dx

@@GoOn:
        mov     es,ds:[si]._data

        mov     bx,@@y1
        movzx   edi,@@x1
        shl     bx,2
        add     edi,ds:[si].LineOffsets[bx]
        shld    ebx,edi,16

        cmp     bx,ds:[si]._CurWriteBank
        je      short @@nobankSwitch

;   { change page; call VESA }
        mov     ds:[si]._CurWriteBank,bx  ; { reset to new page }
        add     bx,bx
        mov     dx,ds:[si]._BankVals[bx]
        xor     bx,bx
        call    ds:[si].dword ptr SwitchBank

@@nobankSwitch:

        mov     al,byte ptr @@colour
        mov     ah,al
        push    ax
        push    ax
        pop     eax

        mov     bx,di
        sub     bx,@@x1
        jc      short @@foo
        add     bx,@@x2
        jc      short @@Crossbank
@@foo:  mov     cx,@@x2
        sub     cx,@@x1
        inc     cx
        jmp     short @@draw
@@crossbank:

        xor     cx,cx
        sub     cx,di
        mov     bx,cx

        mov     dx,cx

        and     dx,3
        shr     cx,2
        rep     stosd
        mov     cx,dx
        rep     stosb

        mov     cx,@@x2
        sub     cx,@@x1
        sub     cx,bx
        inc     cx

        push    ax
        inc     ds:[si]._CurWriteBank
        mov     bx,ds:[si]._CurWriteBank
        add     bx,bx
        mov     dx,ds:[si]._BankVals[bx]
        xor     bx,bx
        call    ds:[si].dword ptr SwitchBank
        pop     ax

@@draw:
        mov     dx,cx
        mov     cx,4
        sub     cx,di
        and     cx,3
        sub     dx,cx
        jle     short @@LEndBytes
        rep     stosb
        mov     cx,dx
        and     dx,3
        shr     cx,2
        rep     stosd
@@LEndBytes:
        add     cx,dx
        rep     stosb

        mov     ax,ds:[si]._ReadWindow
        test    ax,ax
        jnz     @@done
        mov     ax,ds:[si]._CurWriteBank
        mov     ds:[si]._CurReadBank,ax
@@done:
        pop     ds

        ret
endp TScreen8@horizline

TScreen8@putblit proc
arg @@x:word,@@y:word,@@blit:pword,@@self:dword
local @@xres:word,@@changedBank:word

        lfs     si,@@self

        cmp     fs:[si]._LFB,FALSE
        je      short @@NoLFB
        push    @@x
        push    @@y
        push    @@blit
        push    @@self
        call    TGfx8@PutBlit
        ret
@@NoLfb:
        push    ds

        mov     es,fs:[si]._data       ; es should be sega000
        mov     ax,fs:[si].xres
        mov     @@xres,ax

        mov     bx,@@y
        shl     bx,2
        movzx   edi,@@x
        add     edi,fs:[si].LineOffsets[bx]
        shld    ebx,edi,16
        and     edi,0ffffh                   ; es:[di] -> screen

        cmp     bx,fs:[si]._CurWriteBank
        je      short @@inbank

;   { change page; call VESA }
        mov     fs:[si]._CurWriteBank,bx  ; { reset to new page }
        add     bx,bx
        mov     dx,fs:[si]._BankVals[bx]
        xor     bx,bx
        call    fs:[si].dword ptr switchbank

@@inbank:
        xor     edx,edx
        xor     ecx,ecx
        xor     ebx,ebx

        lds     esi,@@blit
        add     esi,8
        mov     dx,ds:[esi]
        add     esi,edx
        shr     dx,33
        test    dx,dx
        jz      short @@done
@@yloop:
        push    dx
        push    di

        mov     @@ChangedBank,FALSE
        movzx   dx,byte ptr ds:[esi]
        inc     esi

        test    dx,dx
        jz      short @@noxLloop
@@xlLoop:
        add     di,ds:[esi]           ; offset to next run
        jnc     short @@noc           ; carry indicates we've crossed a bank
        call    @@incBank             ; change banks
@@noc:
        mov     cx,ds:[esi+2]         ; load count
        mov     ax,di                 ; save starting pos
        add     esi,4                 ; update pointer
        add     ax,cx                 ; add count to starting pos
        jc      short @@CopySplitBank ; carry means we will cross a bank
        shr     cx,33                 ; no carry, so get ready for word moves
        db 67h
        rep     movsw                 ; copy
        jnc     short @@noshrC        ; carry here means odd pixcount
        db 67h
        movsb                         ; move the last one
@@noShrC:
        and     edi,0ffffh            ; es:[di] -> screen
        dec     dx
        jnz     short @@xlLoop
@@NoxLloop:

        pop     di
        add     di,@@xres
        jnc     short @@noc1
        call    @@incBank
@@noc1:
        pop     dx
        dec     dx
        jnz     short @@yloop
@@done:
        pop     ds
        mov     si,word ptr @@self

        mov     ax,fs:[si]._ReadWindow
        test    ax,ax
        jnz     short @@odone
        mov     ax,fs:[si]._CurWriteBank
        mov     fs:[si]._CurReadBank,ax
@@odone: ret

@@IncBank:                           ; this increments the current bank
        cmp     @@ChangedBank,TRUE  ; have we changed already?
        je      short @@noChangeBank ; yes, so don't bother
        push    dx
        push    di
        mov     di,word ptr @@self
        mov     @@ChangedBank,TRUE
        inc     fs:[di]._CurWriteBank
        mov     bx,fs:[di]._CurWriteBank
        add     bx,bx
        mov     dx,fs:[di]._BankVals[bx]
        xor     bx,bx
        call    dword ptr fs:[di].SwitchBank
        pop     di
        pop     dx
@@NoChangeBank:
        retn                        ; return to sender

@@CopySplitBank:

; this section of code copies a run of pixels across banks
; it also completes this line, since we have already incremented the
; bank, and do not want the above inner loop to increment it again
; at least, I think that is why I did that.

        mov     bx,cx
        xor     cx,cx
        sub     cx,di               ; cx=-di
        sub     bx,cx

        db 67h
        rep     movsb
        mov     cx,bx               ;

        call    @@incbank
        xor     edi,edi
        db 67h
        rep     movsb

        dec     dx
        jz      short @@eol
@@fakeloop:
        add     di,ds:[esi]
        mov     cx,ds:[esi+2]
        add     esi,4

        db 67h
        rep     movsb

        dec     dx
        jnz     short @@fakeloop
@@eol:  pop     di
        add     di,@@Xres

        jmp     @@noc1

TScreen8@putblit endp

TScreen8@Putimage proc
arg @@x:word,@@y:word,@@bitmap:pword,@@self:dword
local @@width,@@height,@@xres:word

        lfs     si,@@self

        cmp     fs:[si]._LFB,FALSE
        je      short @@NoLFB
        push    @@x
        push    @@y
        push    @@BitMap
        push    @@self
        call    TGfx8@PutImage
        ret
@@NoLFB:
        mov     es,fs:[si]._data       ; es should be sega000
        mov     ax,fs:[si].xres
        mov     @@xres,ax
        push    ds

        mov     bx,@@y
        shl     bx,2
        movzx   edi,@@x
        add     edi,fs:[si].LineOffsets[bx]
        shld    ebx,edi,16
        and     edi,0ffffh

        cmp     bx,fs:[si]._CurWriteBank
        je      short @@putim

;   { change page; call VESA }
        xor     dx,dx
        mov     fs:[si]._CurWriteBank,bx  ; { reset to new page }
        add     bx,bx
        mov     dx,fs:[si]._BankVals[bx]
        xor     bx,bx
        call    fs:[si].dword ptr switchbank
@@putim:
        lds     esi,@@bitmap

        mov     ax,ds:[esi]     ; {Get width}
        mov     bx,ds:[esi+2]   ; {get height}
        mov     @@width,ax
        mov     @@height,bx
        add     esi,4
        mov     bx,di
        add     bx,@@width     ; {bx=y*640+x+width}

@@top:  push    di
        cmp     bx,di
        jb      short @@CopySplitBank

        mov     cx,@@width

        mov     dx,cx
        and     dx,3
        shr     cx,2
        db 67h
        rep     movsd
        mov     cx,dx
        db 67h
        rep     movsb

@@dropline:
        add     bx,@@xres
        pop     di
        add     di,@@xres
        jc      short @@BankChange
@@GoBack:
        dec     @@height
        jnz     short @@top

        pop     ds
        mov     si,word ptr @@self
        mov     ax,fs:[si]._ReadWindow
        test    ax,ax
        jnz     short @@DiffBank
        mov     ax,fs:[si]._CurWriteBank           ;{This keeps both read and write banks}
        mov     fs:[si]._CurReadBank,ax       ;{normalized if the windows are the same}
@@DiffBank:

        ret

@@CopySplitBank:
        push    bx

        xor     cx,cx
        sub     cx,di
        mov     dx,cx

        mov     bx,cx
        and     bx,3
        shr     cx,2
        db 67h
        rep     movsd
        mov     cx,bx
        db 67h
        rep     movsb

        mov     cx,@@width
        sub     cx,dx

        push    si
        mov     si,word ptr @@self
        inc     fs:[si]._CurWriteBank
        mov     bx,fs:[si]._CurWriteBank
        add     bx,bx
        mov     dx,fs:[si]._BankVals[bx]
        xor     bx,bx
        call    fs:[si].dword ptr SwitchBank
        and     edi,0ffffh
        pop     si

        mov     bx,cx
        and     bx,3
        shr     cx,2
        db 67h
        rep     movsd
        mov     cx,bx
        db 67h
        rep     movsb

        pop     bx
        pop     di

        add     bx,@@xres
        add     di,@@xres

        jmp     short @@GoBack
@@BankChange:

        push    bx
        push    si
        mov      si,word ptr @@self
        inc     fs:[si]._CurWriteBank
        mov     bx,fs:[si]._CurWriteBank
        add     bx,bx
        mov     dx,fs:[si]._BankVals[bx]
        xor     bx,bx
        call    fs:[si].dword ptr SwitchBank
        and     edi,0ffffh
        pop     si
        pop     bx
        jmp     @@Goback
endp TScreen8@putimage

TScreen8@putpixel proc
arg @@x:word,@@y:word,@@colour:dword,@@self:dword

        les     si,@@self

        cmp     es:[si]._LFB,FALSE
         je     short @@NoLFB
        push    word ptr @@x
        push    word ptr @@y
        push    dword ptr @@colour
        push    dword ptr @@self
        call    TGfx8@PutPixel
        ret
@@NoLFB:
        mov     bx,@@y
        cmp     bx,es:[si].GetMaxY
         ja     short @@NoPutPix
        movzx   edi,@@x
        cmp     di,es:[si].GetMaxX
         ja     short @@noPutPix
        shl     bx,2
        add     edi,es:[si].LineOffsets[bx]

        shld    ebx,edi,16

        cmp     bx,es:[si]._CurWriteBank
         je     short @@ppix

;   { change page; call VESA }
        mov     es:[si]._CurWriteBank,bx  ; { reset to new page }
        add     bx,bx
        mov     dx,es:[si]._BankVals[bx]
        xor     bx,bx
        call    dword ptr es:[si].SwitchBank

        mov     ax,es:[si]._ReadWindow
        test    ax,ax
         jnz    short @@ppix
        mov     ax,es:[si]._CurWriteBank
        mov     es:[si]._CurReadBank,ax

@@ppix: mov     es,es:[si]._data
        mov     al,byte ptr @@colour
        mov     es:[di],al
@@NoPutPix:
        ret
TScreen8@putpixel endp

TScreen8@rawline proc
arg @@x1:word,@@y1:word,@@x2:word,@@y2:word,@@colour:dword,@@self:dword
local @@tc:word,@@xres:dword

        push    ds
        lds     si,@@self
        cmp     ds:[si]._LFB,FALSE
        je      short @@noLFB
        pop     ds
        push    @@x1
        push    @@y1
        push    @@x2
        push    @@y2
        push    @@colour
        push    @@self
        call    TGfx8@RawLine
        ret
@@NoLFB:
        mov     es,ds:[si]._Data
        movzx   eax,ds:[si].Xres
        mov     @@xres,eax

        mov     bx,@@y1
        shl     bx,2
        mov     edi,ds:[si].LineOffsets[bx]
        movzx   eax,@@x1
        add     edi,eax
        shld    ebx,edi,16

        cmp     bx,ds:[si]._CurWriteBank
        je      short @@linestart

;   { change page; call VESA }
        mov     ds:[si]._CurWriteBank,bx  ; { reset to new page }
        add     bx,bx
        mov     dx,ds:[si]._BankVals[bx]
        xor     bx,bx
        call    ds:[si].dword ptr SwitchBank

@@linestart:

        mov     bx,@@Y2
        shl     bx,2
        mov     esi,ds:[si].LineOffsets[bx]
        movzx   eax,@@x2
        add     esi,eax

        mov     ax,@@x2
        mov     bx,@@y2
        sub     ax,@@x1
        sub     bx,@@y1
        mov     ecx,1
        mov     edx,@@Xres
        bt      ax,15
        jnc     short @@xpositive
        or      ecx,-1             ;{this is faster than moving -1 into ecx}
        neg     ax
@@xpositive:
        add     ax,ax
        bt      bx,15
        jnc     short @@ypositive
        mov     edx,@@xres
        neg     edx
        neg     bx
@@ypositive:
        add     bx,bx

        cmp     ax,bx
        jle     short @@ygreater
        push    cx
        mov     cx,ax
        mov     @@tc,bx
        shr     cx,33
        sub     @@tc,cx
        pop     cx

@@xtop:
        push    eax
        shld    eax,edi,16
        push    si
        mov     si,word ptr @@self
        cmp     ax,ds:[si]._CurWriteBank
        pop     si
        je      short @@noset1
        call    @@setb
@@noset1:
        mov     al,byte ptr @@colour
        mov     es:[di],al
        pop     eax
        cmp     esi,edi
        je      short @@done
        cmp     @@tc,0
        jl      short @@noaddy
        add     edi,edx
        sub     @@tc,ax
@@noaddy:
        add     edi,ecx
        add     @@tc,bx

        jmp     short @@xtop

@@ygreater:
        push    cx
        mov     cx,bx
        mov     @@tc,ax
        shr     cx,33
        sub     @@tc,cx
        pop     cx

@@ytop: push    eax
        shld    eax,edi,16
        push    si
        mov     si,word ptr @@self
        cmp     ax,ds:[si]._CurWriteBank
        pop     si
        je      short @@noset2
        call    @@setb
@@noset2:
        mov     al,byte ptr @@colour
        mov     es:[di],al
        pop     eax
        cmp     esi,edi
        je      short @@done
        cmp     @@tc,0
        jl      short @@noaddx
        add     edi,ecx
        sub     @@tc,bx
@@noaddx:
        add     edi,edx
        add     @@tc,ax
        jmp     short @@ytop
@@done:
        lds     si,@@self
        mov     ax,ds:[si]._ReadWindow
        test    ax,ax
        jnz     @@odone
        mov     ax,ds:[si]._CurWriteBank
        mov     ds:[si]._CurReadBank,ax
@@odone:
        pop     ds
        ret

@@setb: push    bx cx dx si

        mov     si,word ptr @@self
        mov     ds:[si]._CurWriteBank,ax        ;{ reset to new page }
        xor     dx,dx
        mov     bx,ax
        add     bx,bx
        mov     dx,ds:[si]._BankVals[bx]
        xor     bx,bx
        mov     ax,4f05h
        call    ds:[si].dword ptr SwitchBank

        pop     si dx cx bx
        retn

TScreen8@rawline endp

;procedure vesa8.scalebuf(dX1,dY1,dX2,dY2:integer;SrcObject:gfx8;sx1,sy1,sx2,sy2:word);

TScreen8@ScaleBuf proc
arg @@dX1:word,@@dY1:word,@@dX2:word,@@dY2:word,@@SrcObject:dword,@@sx1:word,@@sy1:word,@@sx2:word,@@sy2:word,@@self:dword
local @@xres:word,@@xinc:dword,@@yinc:dword

        les     di,@@self
        cmp     es:[di]._LFB,FALSE
        je      short @@NoLFB
        push    @@dx1
        push    @@dy1
        push    @@dx2
        push    @@dy2
        push    @@SrcObject
        push    @@sx1
        push    @@sy1
        push    @@sx2
        push    @@sy2
        push    @@self
        call    TGfx8@ScaleBuf
        ret
@@NoLFB:
        mov     ax,@@sx1
        cmp     ax,@@sx2
        jb      short @@noswapsx
        push    @@sx2
        mov     @@sx2,ax
        pop     @@sx1
@@noswapsx:
        mov     ax,@@sy1
        cmp     ax,@@sy2
        jb      short @@noswapsy
        push    @@sy2
        mov     @@sy2,ax
        pop     @@sy1
@@noswapsy:

        mov     ax,@@dx1
        cmp     ax,@@dx2
        jb      short @@noswapdx
        push    @@dx2
        mov     @@dx2,ax
        pop     @@dx1
@@noswapdx:
        mov     ax,@@dy1
        cmp     ax,@@dy2
        jb      short @@noswapdy
        push    @@dy2
        mov     @@dy2,ax
        pop     @@dy1
@@noswapdy:

        mov     ax,@@dx2
        sub     ax,@@dx1
        inc     ax

        cmp     ax,0
        jle     @@nomoreloops

        xor     dx,dx
        push    dx
        push    ax
        mov     ax,@@sx2
        sub     ax,@@sx1
        inc     ax
        xor     dx,dx
        mov     cx,16
        xor     bx,bx
        call    @@mulsetup
        pop     cx
        pop     bx
        call    @@mul
        mov     word ptr @@xinc,ax
        mov     word ptr @@xinc+2,dx


        mov     ax,@@dy2
        sub     ax,@@dy1
        inc     ax

        cmp     ax,0
        jle     @@nomoreloops

        xor     dx,dx
        push    dx
        push    ax
        mov     ax,@@sy2
        sub     ax,@@sy1
        inc     ax
        xor     dx,dx
        mov     cx,16
        xor     bx,bx
        call    @@mulsetup
        pop     cx
        pop     bx
        call    @@mul
        mov     word ptr @@yinc,ax
        mov     word ptr @@yinc+2,dx

        cmp     @@dx1,0
        jge     short @@dx1InRange
        mov     @@dx1,0
@@dx1InRange:

        cmp     @@dy1,0
        jge     short @@dy1InRange
        mov     @@dy1,0
@@dy1InRange:

        push    ds

        lds     si,@@self

        mov     ax,ds:[si].GetMaxX

        cmp     @@dx2,ax
        jl      short @@dx2inrange
        mov     @@dx2,ax
@@dx2inrange:

        mov     ax,ds:[si].GetMaxY
        cmp     @@dy2,ax
        jl      short @@dy2InRange
        mov     @@dy2,ax
@@dy2InRange:

        push    ds
        pop     fs

        mov     bx,@@dy1
        movzx   edi,@@dx1
        shl     bx,2
        add     edi,ds:[si].LineOffsets[bx] ; edi=dy1*xres+dx1

        mov     es,ds:[si]._data

        shld    ebx,edi,16
        cmp     bx,ds:[si]._CurWriteBank
        je      short @@continue

;   { change page; call VESA }
        mov     ds:[si]._CurWriteBank,bx  ; { reset to new page }
        add     bx,bx
        mov     dx,ds:[si]._BankVals[bx]
        xor     bx,bx
        call    ds:[si].dword ptr switchbank
@@continue:
        mov     ax,ds:[si].xres
        mov     @@Xres,ax

        mov     ax,@@dX1
        dec     ax          ; because (a-b)+1 is equal to a-(b-1)
        sub     @@dx2,ax    ; {@@dx2 is now width}

        mov     ax,@@dY1
        dec     ax
        sub     @@dy2,ax    ; {@@dy2 is now height}

        lgs     si,@@SrcObject

        mov     ds,gs:[si]._data

        movzx   ebx,@@sy1
        shl     ebx,16

@@mainloop:
        push    @@dx2
        push    edi

        push    ebx
        mov     si,word ptr @@SrcObject
        movzx   edx,@@sx1
        shr     ebx,16
        shl     bx,2
        add     edx,gs:[si].LineOffsets[bx]
        add     edx,gs:[si]._InternalOffset
        mov     esi,edx
        pop     ebx

        xor     ecx,ecx

        add     di,@@dx2
        sub     di,@@dx2
        jnc     short @@innerloop
;{ crosses bank}

        push    bx
        add     @@dx2,di
        xor     bx,bx
        sub     bx,di

@@splitbankinnerloop1:
        mov     al,ds:[esi]
        add     ecx,@@xinc
        mov     es:[di],al
        inc     di
        mov     esi,ecx
        shr     esi,16
        add     esi,edx
        dec     bx
        jnz     short @@splitbankinnerloop1

        call    @@incbank

        pop     bx
        cmp     @@dx2,0
        je      short @@nomoresplit
@@splitbankinnerloop2:
        mov     al,ds:[esi]
        add     ecx,@@xinc
        mov     es:[di],al
        inc     di
        mov     esi,ecx
        shr     esi,16
        add     esi,edx
        dec     @@dx2
        jnz     short @@splitbankinnerloop2
@@nomoresplit:
        pop     edi
        add     ebx,@@yinc
        add     di,@@xres
        pop     @@dx2
        dec     @@dy2
        jnz     @@mainloop
        jmp     short @@nomoreloops

@@innerloop:
        mov     al,ds:[esi]
        add     ecx,@@xinc
        mov     es:[di],al
        inc     di
        mov     esi,ecx
        shr     esi,16
        add     esi,edx
        dec     @@dx2
        jnz     short @@innerloop

@@nextline:
        pop     edi
        add     ebx,@@yinc
        add     di,@@xres
        jnc     short @@noincbank
        call    @@incbank
@@noIncBank:
        pop     @@dx2
        dec     @@dy2
        jnz     @@mainloop

@@nomoreloops:

        lds     si,@@self
        mov     ax,ds:[si]._ReadWindow
        test    ax,ax
        jnz     @@DiffBank
        mov     ax,ds:[si]._CurWriteBank
        mov     ds:[si]._CurReadBank,ax
@@DiffBank:
        pop     ds
        ret

@@incbank:
        push    bx
        push    dx
        push    si
        mov     si,word ptr @@self
        inc     fs:[si]._CurWriteBank
        mov     bx,fs:[si]._CurWriteBank
        add     bx,bx
        mov     dx,fs:[si]._BankVals[bx]
        xor     bx,bx
        call    fs:[si].dword ptr SwitchBank
        pop     si
        pop     dx
        pop     bx
        retn

@@mulsetup:
        shl     edx,16
        mov     dx,ax
        shl     edx,cl
        mov     ax,dx
        shr     edx,16
        retn
@@mul:
        shl     eax,16
        shrd    eax,edx,16
        shl     ecx,16
        shrd    ecx,ebx,16
        cdq
        idiv    ecx
        mov     ecx,edx
        shld    edx,eax,16
        shld    ebx,ecx,16
        retn
endp TScreen8@ScaleBuf

TScreen8@Vertline proc
arg @@x:word,@@y1:word,@@y2:word,@@colour:dword,@@self:dword;

        push    ds

        lds     si,@@self
        cmp     ds:[si]._LFB,FALSE
        je      short @@NoLFB
        pop     ds
        push    @@x
        push    @@y1
        push    @@y2
        push    @@colour
        push    @@self
        call    TGfx8@VertLine
        ret
@@NoLFB:
        mov     ax,@@y1
        cmp     ax,@@y2
        jle     short @@noswap
        push    @@y2
        mov     @@y2,ax
        pop     @@y1
@@noswap:
        mov     ax,@@x
        cmp     ax,ds:[si].GetMaxX  ; is the lineseg off the screen?
        ja      @@done

        mov     ax,@@y1
        mov     bx,@@y2
        mov     dx,ds:[si].GetMaxY

        cmp     ax,0
        jge     @@checkMaxY
        mov     @@y1,0
        cmp     bx,0
        jl      @@done

@@checkMaxY:

        cmp     bx,dx   ; is the lineseg off the screen?
        jle     @@GoOn
        mov     @@y2,dx
        cmp     ax,dx
        jg      @@done
@@GoOn:
        mov     es,ds:[si]._data

        mov     bx,@@y1
        movzx   edi,@@x
        shl     bx,2
        add     edi,ds:[si].LineOffsets[bx]
        shld    ebx,edi,16

        cmp     bx,ds:[si]._CurWriteBank
        je      @@writeline
;   { change page; call VESA }
        mov     ds:[si]._CurWriteBank,bx  ; { reset to new page }
        add     bx,bx
        mov     dx,ds:[si]._BankVals[bx]
        xor     bx,bx
        call    ds:[si].dword ptr SwitchBank

@@writeline:
        mov     cx,@@y2
        sub     cx,@@y1
        inc     cx

        mov     al,byte ptr @@colour

@@lop:  mov     es:[di],al
        add     di,ds:[si].xres
        jc      @@changebank
        dec     cx
        jnz     @@lop
        jmp     @@done
@@ChangeBank:
        push    ax
        inc     ds:[si]._CurWriteBank
        mov     bx,ds:[si]._CurWriteBank
        add     bx,bx
        mov     dx,ds:[si]._BankVals[bx]
        xor     bx,bx
        call    ds:[si].dword ptr SwitchBank
        pop     ax
        dec     cx
        jnz     @@lop
@@done:
        mov     ax,ds:[si]._ReadWindow
        test    ax,ax
        jnz     @@DiffBank
        mov     ax,ds:[si]._CurWriteBank
        mov     ds:[si]._CurReadBank,ax
@@DiffBank:
        pop     ds
        ret
endp TScreen8@Vertline

CODE ENDS
     END

